<template>
  <el-select
    v-model="selected"
    placeholder="Рекламодатели"
    @change="onChange"
    :remote-method="search"
    :loading="isLoading"
    :disabled="isDisabled"
    :loading-text="'Поиск...'"
    :no-data-text="'Нет данных'"
    :no-match-text="'Совпадения не найдены'"
    remote
    multiple
    filterable
    collapse-tags
  >
    <el-option
      v-for="advertiser in options"
      :key="advertiser.id"
      :label="shortName(advertiser.name)"
      :value="advertiser.id"
    >
      <span class="id">{{ advertiser.id }}</span>
      <span class="name">{{ advertiser.name }}</span>
    </el-option>
  </el-select>
</template>

<script lang="ts">
import { Component, Mixins } from "vue-property-decorator";
import { Advertiser } from "@/interfaces/Advertiser";
import { SellingDirection } from "@/interfaces/SellingDirection";
import { AxiosInstance } from "@/modules/AxiosInstance";
import ComponentMixin from "@/components/common/ComponentMixin";
import { AsyncRequestCatchException } from "@/decorators/AsyncExceptionCatch";

/**
 * Компонент - поле выбора рекламодателей.
 */
@Component
export default class ComponentSelectAdvertiser extends Mixins(ComponentMixin) {
  /** @property {number[]} selected - коллекция идентификаторов выбранных рекламодателей. */
  private selected: number[] = [];
  /** @property {Advertiser[]} options - коллекция отфильтрованных рекламодателей. */
  private options: Advertiser[] = [];
  /** @property {Advertiser[]} advertisers - коллекция рекламодателей. */
  private advertisers: Advertiser[] = [];
  /** @property {boolean} isLoading - признак "данные загружаются". */
  private isLoading = false;
  /** @property {boolean} isDisabled - признак "элемент неактивен". */
  private isDisabled = true;
  /** @property {string} eventName - название события, которое генерирует компонент. */
  private readonly eventName = "on-selected-advertisers";

  /**
   * Метод срабатывает после создания компонента.
   */
  protected created(): void {
    // Подписываемся на событие изменения выбранного направления продаж
    this.subscribe(
      "on-selected-selling-direction",
      this.onSellingDirectionChanged
    );
  }

  /**
   * Метод срабатывает после изменения выбранного направления продаж.
   *
   * @property {SellingDirection|null} sellingDirection - выбранное направление продаж.
   */
  private onSellingDirectionChanged(
    sellingDirection: SellingDirection | null
  ): void {
    // Если направление продаж не выбрано, то завершаем выполнение метода и очищаем список каналов.
    if (!sellingDirection) {
      this.clearAll();
      return;
    }

    // Иначе отправляем запрос на сервер
    this.getAdvertisersBySellingDirectionID(sellingDirection.id);
  }

  /**
   * Метод запроса коллекции рекламодателей по указанному ID направления продаж.
   * @param {number} id ID выбранного направления продаж.
   */
  @AsyncRequestCatchException
  private async getAdvertisersBySellingDirectionID(id: number): Promise<void> {
    // Очищаем свойства компонента
    this.clearAll();

    // Отправляем запрос на сервер
    const response = await AxiosInstance.get(
      "media-plan-search-view/get-advertisers-by-selling-direction",
      { params: { id: id } }
    );

    // Если нет данных - завершаем выполнение метода
    if (!response.data) return;

    // Сохраняем новую коллекцию каналов
    this.advertisers = (response.data as Advertiser[]).sort((a, b) =>
      a.name.localeCompare(b.name)
    );
    this.options = this.advertisers;

    // Переключаем признак "компонент неактивен"
    this.isDisabled = false;
  }

  /**
   * Метод срабатывает после выбора рекламодателей.
   */
  private onChange(): void {
    // Ищем выбранных рекламодателей по выбранным идентификаторам
    const selectedAdvertisers = this.advertisers.filter((advertiser) =>
      this.selected.includes(advertiser.id)
    );
    // Оповещаем подписчиков об изменении выбранных рекламодателей
    this.notify(this.eventName, selectedAdvertisers);
  }

  /**
   * Метод поиска рекламодателя по названию.
   *
   * @param {string} text - строка поиска.
   */
  private search(text: string): void {
    // Переключаем признак "данные загружаются"
    this.isLoading = true;

    // Эмулируем запрос с задержкой в 200мс
    setTimeout(() => {
      // Фильтруем коллекцию рекламодателей
      this.options = this.advertisers.filter(
        (advertiser) =>
          advertiser.name.toLowerCase().indexOf(text.toLowerCase()) !== -1
      );
      // Переключаем признак "данные загружаются"
      this.isLoading = false;
    }, 200);
  }

  /**
   * Метод укорачивания названия рекламодателя.
   *
   * @param {string} name - название рекламодателя.
   *
   * @return {string} короткое название рекламодателя.
   */
  private shortName(name: string): string {
    // Если длина строки больше 7 символов - возвращаем укороченную строку
    if (name.length > 7) {
      return name.substr(0, 7) + "...";
    }
    // Иначе возвращаем туже самую
    return name;
  }

  /**
   * Метод очистки свойств компонента.
   */
  private clearAll(): void {
    // Переключаем признак "компонент неактивен"
    this.isDisabled = true;
    // Очищаем коллекцию отфильтрованных рекламодателей
    this.options = [];
    // Очщиаем коллекция выбранных рекламодателей
    this.selected = [];
    // Очищаем коллекцию рекламодателей.
    this.advertisers = [];
    // Оповещаем подписчиков о том что рекламодатель не выбран
    this.notify(this.eventName, null);
  }
}
</script>

<style lang="scss" scoped>
.el-select {
  width: 100%;
  margin-bottom: 2%;
}
</style>
